'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utilsBrowserUtils = require('./utils/browser-utils');

var _utilsTreeDataUtils = require('./utils/tree-data-utils');

var _reactIconsLibFa = require('react-icons/lib/fa');

var styles = undefined;
// Add extra classes in browsers that don't support flex
if (_utilsBrowserUtils.getIEVersion < 10) {
	styles = {
		row: 'row row_NoFlex',
		rowContents: 'rowContents rowContents_NoFlex',
		rowLabel: 'rowLabel rowLabel_NoFlex',
		rowToolbar: 'rowToolbar rowToolbar_NoFlex'
	};
}

var AdainTreeNodeRenderDefault = (function (_React$Component) {
	_inherits(AdainTreeNodeRenderDefault, _React$Component);

	function AdainTreeNodeRenderDefault(props) {
		_classCallCheck(this, AdainTreeNodeRenderDefault);

		_get(Object.getPrototypeOf(AdainTreeNodeRenderDefault.prototype), 'constructor', this).call(this, props);

		this.titleField = this.props.titleField || 'title';
	}

	_createClass(AdainTreeNodeRenderDefault, [{
		key: 'render',
		value: function render() {
			var _props = this.props;
			var scaffoldBlockPxWidth = _props.scaffoldBlockPxWidth;
			var toggleChildrenVisibility = _props.toggleChildrenVisibility;
			var connectDragPreview = _props.connectDragPreview;
			var connectDragSource = _props.connectDragSource;
			var isDragging = _props.isDragging;
			var canDrop = _props.canDrop;
			var canDrag = _props.canDrag;
			var node = _props.node;
			var draggedNode = _props.draggedNode;
			var path = _props.path;
			var treeIndex = _props.treeIndex;
			var isSearchMatch = _props.isSearchMatch;
			var isSearchFocus = _props.isSearchFocus;
			var buttons = _props.buttons;
			var className = _props.className;
			var style = _props.style;
			var didDrop = _props.didDrop;
			var onRowClick = _props.onRowClick;
			var onChangeCheckBox = _props.onChangeCheckBox;
			var commonSetting = _props.commonSetting;
			var _isOver = _props.isOver;
			var _parentNode = _props.parentNode;
			var _endDrag = _props.endDrag;
			var _startDrag = _props.startDrag;
			var _scaffold = _props.scaffold;

			var otherProps = _objectWithoutProperties(_props, ['scaffoldBlockPxWidth', 'toggleChildrenVisibility', 'connectDragPreview', 'connectDragSource', 'isDragging', 'canDrop', 'canDrag', 'node', 'draggedNode', 'path', 'treeIndex', 'isSearchMatch', 'isSearchFocus', 'buttons', 'className', 'style', 'didDrop', 'onRowClick', 'onChangeCheckBox', 'commonSetting', 'isOver', 'parentNode', 'endDrag', 'startDrag', 'scaffold']);

			var handle = undefined;
			if (canDrag) {
				if (typeof node.children === 'function' && node.expanded) {
					// Show a loading symbol on the handle when the children are expanded
					//  and yet still defined by a function (a callback to fetch the children)
					handle = _react2['default'].createElement(
						'div',
						{ className: 'loadingHandle' },
						_react2['default'].createElement(
							'div',
							{ className: 'loadingCircle' },
							_react2['default'].createElement('div', { className: 'loadingCirclePoint' }),
							_react2['default'].createElement('div', { className: 'oadingCirclePoint' }),
							_react2['default'].createElement('div', { className: 'oadingCirclePoint' }),
							_react2['default'].createElement('div', { className: 'oadingCirclePoint' }),
							_react2['default'].createElement('div', { className: 'oadingCirclePoint' }),
							_react2['default'].createElement('div', { className: 'oadingCirclePoint' }),
							_react2['default'].createElement('div', { className: 'oadingCirclePoint' }),
							_react2['default'].createElement('div', { className: 'oadingCirclePoint' }),
							_react2['default'].createElement('div', { className: 'oadingCirclePoint' }),
							_react2['default'].createElement('div', { className: 'oadingCirclePoint' }),
							_react2['default'].createElement('div', { className: 'oadingCirclePoint' }),
							_react2['default'].createElement('div', { className: 'oadingCirclePoint' })
						)
					);
				} else {
					// Show the handle used to initiate a drag-and-drop
					handle = connectDragSource(_react2['default'].createElement('div', { className: 'moveHandle' }), {
						dropEffect: 'copy'
					});
				}
			}

			var isDraggedDescendant = draggedNode && (0, _utilsTreeDataUtils.isDescendant)(draggedNode, node);
			var isLandingPadActive = !didDrop && isDragging;

			var hasCheckBox = commonSetting && commonSetting.hasCheckBoxAll || node.hasCheckBox;
			node.checked = node.checked || false;

			return _react2['default'].createElement(
				'div',
				_extends({ ref: 'row', className: 'nodeContentWrap' + (node.selected ? ' checked' : '') }, otherProps, { onClick: function () {
						return onRowClick({ node: node, path: path, treeIndex: treeIndex });
					} }),
				handle,
				_react2['default'].createElement(
					'div',
					{ className: 'checkWrap' },
					hasCheckBox && _react2['default'].createElement(
						'div',
						{ className: 'checkBoxs' },
						_react2['default'].createElement('input', { type: 'checkbox', checked: node.checked, onChange: function (e) {
								return onChangeCheckBox({ e: e, node: node, path: path, treeIndex: treeIndex });
							} })
					)
				),
				_scaffold,
				_react2['default'].createElement(
					'div',
					{ className: 'rowWrapper' },
					connectDragPreview(_react2['default'].createElement(
						'div',
						{
							className: 'row' + (isLandingPadActive ? ' rowLandingPad' : '') + (isLandingPadActive && !canDrop ? ' rowCancelPad' : '') + (isSearchMatch ? ' rowSearchMatch' : '') + (isSearchFocus ? ' rowSearchFocus' : '') + (className ? ' ' + className : ''),
							style: _extends({
								opacity: isDraggedDescendant ? 0.5 : 1
							}, style)
						},
						_react2['default'].createElement(
							'div',
							{ className: 'rowContents' + (!canDrag ? ' rowContentsDragDisabled' : '') },
							_react2['default'].createElement(
								'div',
								{ className: 'rowLabel' },
								toggleChildrenVisibility && node.children && node.children.length > 0 ? _react2['default'].createElement(
									'div',
									{ className: 'folderWrap' },
									_react2['default'].createElement(
										'button',
										{
											type: 'button',
											'aria-label': node.expanded ? 'Collapse' : 'Expand',
											className: node.expanded ? "collapseButton" : "expandButton",
											onClick: function () {
												return toggleChildrenVisibility({ node: node, path: path, treeIndex: treeIndex });
											}
										},
										node.expanded ? _react2['default'].createElement(_reactIconsLibFa.FaFolderOpen, null) : _react2['default'].createElement(_reactIconsLibFa.FaFolder, null)
									),
									node.expanded && !isDragging && _react2['default'].createElement('div', { className: 'lineChildren' })
								) : _react2['default'].createElement('div', { className: 'noChildren' }),
								_react2['default'].createElement(
									'span',
									{
										className: "rowTitle" + (node.subtitle ? ' rowTitleWithSubtitle' : '')
									},
									typeof node[this.titleField] === 'function' ? node[this.titleField]({
										node: node,
										path: path,
										treeIndex: treeIndex
									}) : node[this.titleField]
								),
								node.subtitle && _react2['default'].createElement(
									'span',
									{ className: 'rowSubtitle' },
									typeof node.subtitle === 'function' ? node.subtitle({
										node: node,
										path: path,
										treeIndex: treeIndex
									}) : node.subtitle
								)
							),
							_react2['default'].createElement(
								'div',
								{ className: 'rowToolbar' },
								buttons.map(function (btn, index) {
									return _react2['default'].createElement(
										'div',
										{
											key: index, // eslint-disable-line react/no-array-index-key
											className: 'toolbarButton'
										},
										btn
									);
								})
							)
						)
					))
				)
			);
		}
	}]);

	return AdainTreeNodeRenderDefault;
})(_react2['default'].Component);

AdainTreeNodeRenderDefault.defaultProps = {
	isSearchMatch: false,
	isSearchFocus: false,
	canDrag: false,
	toggleChildrenVisibility: null,
	buttons: [],
	className: '',
	style: {},
	parentNode: null,
	draggedNode: null,
	canDrop: false
};

AdainTreeNodeRenderDefault.propTypes = {
	node: _propTypes2['default'].shape({}).isRequired,
	path: _propTypes2['default'].arrayOf(_propTypes2['default'].oneOfType([_propTypes2['default'].string, _propTypes2['default'].number])).isRequired,
	treeIndex: _propTypes2['default'].number.isRequired,
	isSearchMatch: _propTypes2['default'].bool,
	isSearchFocus: _propTypes2['default'].bool,
	canDrag: _propTypes2['default'].bool,
	scaffoldBlockPxWidth: _propTypes2['default'].number.isRequired,
	toggleChildrenVisibility: _propTypes2['default'].func,
	buttons: _propTypes2['default'].arrayOf(_propTypes2['default'].node),
	className: _propTypes2['default'].string,
	style: _propTypes2['default'].shape({}),

	onRowClick: _propTypes2['default'].func,
	onChangeCheckBox: _propTypes2['default'].func,

	// Drag and drop API functions
	// Drag source
	connectDragPreview: _propTypes2['default'].func.isRequired,
	connectDragSource: _propTypes2['default'].func.isRequired,
	parentNode: _propTypes2['default'].shape({}), // Needed for drag-and-drop utils
	startDrag: _propTypes2['default'].func.isRequired, // Needed for drag-and-drop utils
	endDrag: _propTypes2['default'].func.isRequired, // Needed for drag-and-drop utils
	isDragging: _propTypes2['default'].bool.isRequired,
	didDrop: _propTypes2['default'].bool.isRequired,
	draggedNode: _propTypes2['default'].shape({}),
	// Drop target
	isOver: _propTypes2['default'].bool.isRequired,
	canDrop: _propTypes2['default'].bool,
	scaffold: _propTypes2['default'].arrayOf(_propTypes2['default'].node),
	titleField: _propTypes2['default'].string
};

exports['default'] = AdainTreeNodeRenderDefault;
module.exports = exports['default'];

/* eslint-disable no-unused-vars */
// Not needed, but preserved for other renderers
// Needed for drag-and-drop utils
// Needed for drag-and-drop utils
// Needed for drag-and-drop utils

/* eslint-enable no-unused-vars */
/* Set the row preview to be used during drag and drop */